from comptab import fcomp
from inverse import inv
from bitcoding import B_dict
from counters import counter
from glob import globs

DALL = B_dict['DALL']

def varElimination(ConMatrix,neighbors,(a,a_)):
   
   for x in xrange(len(a_)-1,-1,-1):

       neighbs = [y for y in neighbors[a_[x]] if a[y] < x]
       edges = [(y,a_[x]) for y in neighbs if ConMatrix[y][a_[x]] != DALL]

       for (i,k) in edges:
          for (j,k) in edges:
             if i < j:
                temp = fcomp[ConMatrix[i][k]-1][ConMatrix[k][j]-1]
                if temp != DALL:
                   counter['cons'] += 1
                   temp = temp & ConMatrix[i][j]
                   if not temp: 
                      return None
                   if temp != ConMatrix[i][j]: 
                      ConMatrix[i][j] = temp
                      ConMatrix[j][i] = inv[temp-1]
       
   return ConMatrix
